/*
 * Interrupt_Service_Routines.h
 * Created: 2021
 */ 


#ifndef INTERRUPT_SERVICE_ROUTINES_H_
#define INTERRUPT_SERVICE_ROUTINES_H_

unsigned int T2ck; //Counter TMR2 overflow
unsigned char Counter_US; //Counter TMR2 overflow generating a US-trigger every 32ms
extern unsigned char US_Time_L; //Runtime of US signal, HI part
extern unsigned char US_Time_R;
extern unsigned char Line_L3; //Liniensensor Links  Aussen
extern unsigned char Line_L2;
extern unsigned char Line_L1;
extern unsigned char Line_L0; //Liniensensor Links  Mitte
extern unsigned char Line_R0; //Liniensensor Rechts Mitte
extern unsigned char Line_R1;
extern unsigned char Line_R2;
extern unsigned char Line_R3; //Liniensensor Rechts Auen


//TMR2 overflow Interrupt
//To time several works
ISR(TIMER2_OVF_vect) { //Prescaler TMR2 1:8 = Interrupt every 128 us
	//Toggeling the LED, just to see, if the MC is working
	T2ck++; //Counter TMR2 OVF
	if(T2ck == 2000) { //Every 250ms
		T2ck = 0; //Dont forget!!
		//		LED_TOGGLE; //See above
	}
	//Ultrasonic distance
	Counter_US++; //256 * 128us = 32768us
	if (!Counter_US) {//Approx. every 32ms
		//LED_TOGGLE; //for testing
		PORTD |= 0b00010000; //Trigger US, HI
		_delay_us(10); //10 microseconds
		PORTD &= 0b11101111; //Trigger US, LO
		//First you have to write TCNT1H, before writting TCNT1L!!!
		TCNT1H = 0; //Timer 1 set to zero...
		TCNT1L = 0; //...to quantify the distance of the obstacle
		//LED_ON; //Tests
	}

	//Status Line Detector
	Line_L3 = PINC & 0b00000001; //Liniensensor Links  Aussen
	Line_L2 = PINC & 0b00000010;
	Line_L1 = PINC & 0b00000100;
	Line_L0 = PINC & 0b00001000; //Liniensensor Links  Mitte
	Line_R0 = PINC & 0b00010000; //Liniensensor Rechts Mitte
	Line_R1 = PINC & 0b00100000;
	Line_R2 = PINC & 0b01000000;
	Line_R3 = PINC & 0b10000000; //Liniensensor Rechts Auen
}

//Interrupt on falling edge at RD0, US sensor
ISR(INT0_vect) {
	//LED_ON; //Test
	char junk; //Only to read TCNT1L
	junk = TCNT1L; //We have to read the low Byte first, only then we could read TCN1H, but we dont need the value
	US_Time_L = TCNT1H; //runtime of the US signal, HI part
	TCNT1H = 0; //Reset TMR1
	TCNT1L = 0; //Reset
	//16MHz Prescaler 1:8 -> 2MHz TMR1 Counter
	//LED_OFF; //Test
}

ISR(INT1_vect) {
	
}

//Timer 1 Overflow Interrupt
ISR(TIMER1_OVF_vect) { //Prescaler TMR1 1:8 = Interrupt every 32 ms
	US_Time_L = 255; //If there is no obstacle
	//LED_TOGGLE; //for testing
}

#endif /* INTERRUPT_SERVICE_ROUTINES_H_ */